#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <signal.h>

int main(char **argv, int argc) {
  int lp;
  unsigned int i,k;

  lp = open ("/dev/usb/lp0", O_RDWR);

  if (lp == -1) {
    perror("Device open");
    exit(1);
  }

  signal (SIGALRM, SIG_IGN);
  
  {
      //echo    char buf[] = "\033%-98765X>\035\002\004Test";
      unsigned char buf[] = "\033&B\033%-98765X>\035\023\105";/* INFO page decimal 69 */
      //      unsigned char buf[] = "\033&B\033%-98765X>\035\021\000\000";/* U status */
      unsigned char rbuf[255];
      int len,j;
      
      buf[sizeof(buf)-1] = k;
      buf[sizeof(buf)-2] = i;

      write(lp, buf, sizeof(buf));
      write(lp, buf, sizeof(buf));
      write(lp, buf, sizeof(buf));
      
      //      printf("Writing U status command %x %x\n", i, k);
      
      sleep(1);
      alarm(2);
      len = read(lp, rbuf, 255);
      printf("Read %d bytes\n", len);
      
      for (j=0; j<len; j++) {
	printf("%04o %02x %c\n", (int)rbuf[j], (int)rbuf[j], isprint(rbuf[j]) ? rbuf[j] : ' ');
      }

  }
}
